therock = {}

therock.speed = 5 -- Movement speed
therock.maxhealth = 1000 -- Max health (health at the beginning of a round)
therock.statdmg = 50 -- Damage per second
therock.image = "gfx/stoptherock/therock.png" -- Image for The Rock

-- Internal variables --
therock.player = 0
therock.img = 0
therock.health = 1000
therock.oldspeed = 0
therock.df = 2 -- damage factor (not really meant to be changed, but see lines 29 and 31 if you must)

function therock.forward(x,y,ang,factor)
	if ang < -90 then ang = ang + 360 end
	ang = math.rad(math.abs(ang + 90)) - math.pi
	
	return x + math.cos(ang) * factor, y + math.sin(ang) * factor
end

function therock.distance(x1,y1,x2,y2)
	return math.sqrt((x1-x2)^2+(y1-y2)^2)
end

addhook("join","therock.recalculatedmgf")
addhook("leave","therock.recalculatedmgf")
function therock.recalculatedmgf()
	if #player(0,"table") <= 10 then
		therock.df = therock.dmgfactor
	else
		therock.dmgfactor = #player(0,"table")/5
	end
end

addhook("always","therock.moveforward")
function therock.moveforward()
	if therock.player~=0 and player(therock.player,"exists") and player(therock.player,"health")>0 then
		local x, y = therock.forward(player(therock.player,"x"),player(therock.player,"y"),player(therock.player,"rot"),therock.speed)
		if tile(math.floor(x/32),math.floor(y/32),"walkable") then
			parse("setpos "..therock.player.." "..x.." "..y)
			for _, id in pairs(player(0,"tableliving")) do
				if id ~= therock.player and therock.distance(player(id,"x"),player(id,"y"),x,y) <= 16 then
					parse("customkill "..therock.player.." \"rocked\" "..id)
				end
			end
		else
			therock.health = therock.health - therock.statdmg/50
			parse("sethealth "..therock.player.." "..therock.health)
			parse("hudtxt 1 \"\169255255255The Rock's health: "..math.floor(therock.health).."\" 320 100 1")
		end
	end
end

addhook("hit","therock.hit")
function therock.hit(id,src,hpdmg)
	if (id == therock.player) then
		therock.health = therock.health - hpdmg / therock.df
		parse("hudtxt 1 \"\169255255255The Rock's health: "..math.floor(therock.health).."\" 320 100 1")
		parse("sethealth "..therock.player.." "..therock.health)
		return 1
	end
	if (src == therock.player) then
		return 1
	end
end

addhook("walkover","therock.nopickup")
function therock.nopickup(id)
	if (player(id,"team") == 1) then
		return 1
	end
end

addhook("endround","therock.choosenewrock")
function therock.choosenewrock(mode)
	if (not therock.ended) and (mode ~= 3 and mode ~= 4) then
		for _,id in pairs(player(0,"table")) do
			if id ~= rid then
				parse("makect "..id)
			end
		end
		
		if type(therock.oldspeed)=="number" then
			parse("speedmod "..therock.player.." "..therock.oldspeed)
		end
		
		local rid = player(0,"table")[math.random(1, #player(0,"table"))]
		therock.player = rid
		parse("maket "..rid)
		
		therock.ended = true
	end
end

addhook("buy","therock.nobuy")
function therock.nobuy(id)
	if (player(id,"team") == 1) then
		return 1
	end
end

addhook("spawn","therock.spawnstrip")
function therock.spawnstrip(id)
	if id == therock.player then
		freeimage(therock.img)
		therock.img = image(therock.image, 1, 0, 200+id)
		return "x"
	end
end

addhook("startround_prespawn","therock.startround")
function therock.startround(mode)
	if (therock.player == 0 and mode ~= 5) then
		parse("restart")
	else
		therock.ended = false
		msg(player(therock.player,"name").." is The Rock!")
		msg("STOP THE ROCK!@C")
		therock.health = therock.maxhealth
		parse("hudtxt 1 \"\169255255255The Rock's health: "..math.floor(therock.health).."\" 320 100 1")
		therock.oldspeed = player(therock.player,"speed")
		parse("speedmod "..therock.player.." -100")
	end
end

addhook("startround","therock.startround2")
function therock.startround2()
	for _, id in pairs(player(0,"team2")) do
		parse("setmoney "..id.." 16000")
	end
end